_G.NumericalDisplay = class(Turbine.UI.Control);
function NumericalDisplay:Constructor(parent, x, y, textScale)
    Turbine.UI.Control.Constructor(self);
	self:SetParent(parent);
	self:SetSize(x, y);
    width = x;

    self.textScale = textScale;

    self.container = Turbine.UI.Control();
    self.container:SetParent(self);
    self.container:SetSize(0,47);
    self.container:SetTop(-((47*self.textScale)/2));

    self.colonOffset = 20*self.textScale/2;

	self.firstDigit = Turbine.UI.Control();
    self.firstDigit:SetParent(self.container);
    self.firstDigit:SetSize(33, 47);
    self.firstDigit:SetBackground(AGFont[0]);
    self.firstDigit:SetMouseVisible(false);

    self.secondDigit = Turbine.UI.Control();
    self.secondDigit:SetParent(self.container);
    self.secondDigit:SetSize(33, 47);
    self.secondDigit:SetBackground(AGFont[0]);
    self.secondDigit:SetMouseVisible(false);

    self.thirdDigit = Turbine.UI.Control();
    self.thirdDigit:SetParent(self.container);
    self.thirdDigit:SetSize(33, 47);
    self.thirdDigit:SetBackground(AGFont[0]);
    self.thirdDigit:SetMouseVisible(false);

    self.colon = Turbine.UI.Control();
    self.colon:SetParent(self.container);
    self.colon:SetBackground(AGFont[10]);
    self.colon:SetSize(16, 47);
    self.colon:SetMouseVisible(false);
end

function NumericalDisplay:SetText(number)
    local digits = {};
    local totalString = tostring(number);
    self.firstDigit:SetVisible(false);
    self.secondDigit:SetVisible(false);
    self.thirdDigit:SetVisible(false);
    self.colon:SetVisible(false);
    
    if number > 60 then
        totalString = tostring(SecondsToMinutes(number));
        digits[1], digits[2], digits[3]=totalString:match('(%d)(%d)(%d)')
        self:SetImage(self.firstDigit, digits[1]);
        self.colon:SetVisible(true);
        self.colon:SetLeft(self.firstDigit:GetWidth())
        self:SetImage(self.secondDigit, digits[2]);
        self.secondDigit:SetLeft(self.firstDigit:GetWidth()+16)
        self:SetImage(self.thirdDigit, digits[3]);
        self.thirdDigit:SetLeft(self.secondDigit:GetLeft()+self.secondDigit:GetWidth());
        self:ScaleDisplay(self.thirdDigit:GetLeft()+self.thirdDigit:GetWidth());
    elseif number > 9 then
        digits[1], digits[2]=totalString:match('(%d)(%d)')
        self:SetImage(self.firstDigit, digits[1]);
        self:SetImage(self.secondDigit, digits[2]);
        self.secondDigit:SetLeft(self.firstDigit:GetWidth())
        self:ScaleDisplay(self.secondDigit:GetLeft()+self.secondDigit:GetWidth());
    else
        self:SetImage(self.firstDigit, totalString);
        self:ScaleDisplay(self.firstDigit:GetWidth());
    end
end

function NumericalDisplay:SetTextAlignment(alignment)
    if alignment == Turbine.UI.ContentAlignment.MiddleCenter then 
        self.container:SetTop((self:GetHeight()/2) - ((47*self.textScale)/2));
    elseif alignment == Turbine.UI.ContentAlignment.BottomCenter then 
        self.container:SetTop(self:GetHeight() - ((47*self.textScale)/2));
    end
end

function NumericalDisplay:SetImage(control, number)
    control:SetStretchMode(0);
    control:SetBackground(AGFont[tonumber(number)])
    control:SetStretchMode(2);
    control:SetVisible(true);
    control:SetStretchMode(0);
end

function NumericalDisplay:ScaleDisplay(width)
    self.container:SetStretchMode(0);
    self.container:SetWidth(width);
    self.container:SetStretchMode(1);
    self.container:SetSize(self.container:GetWidth()*self.textScale, 47*self.textScale);
    midpoint = (self:GetWidth()/2) - (width*self.textScale)/2;
    self.container:SetLeft(midpoint);
    self.container:SetVisible(true);
end

function NumericalDisplay:Unload()
    self.firstDigit:SetParent(nil);
    self.secondDigit:SetParent(nil);
    self.thirdDigit:SetParent(nil);
    self.colon:SetParent(nil);
    self.firstDigit = nil;
    self.secondDigit = nil;
    self.thirdDigit = nil;
    self.colon = nil;
end